/*---------------------------------------------------------------------------*\
  ==  == ====== ====   ====    |
                    \\     ||  | Multiphase Code Repository by HZDR
  ======   //   ||  || ===//   | Website: https://doi.org/10.14278/rodare.767
  ||  ||  //    ||  // || \\   | License: GPL-3.0-or-later
  ==  == ====== ====   ==  ==  |
-------------------------------------------------------------------------------
License
    This file is part of the Multiphase Code Repository by HZDR.

    Copyright (C) 2025 by Helmholtz-Zentrum Dresden-Rossendorf e.V. (HZDR),
    Website: https://hzdr.de

    Multiphase Code Repository by HZDR is based on the free software for
    computational fluid dynamics (CFD) from the OpenFOAM Foundation.
    Copyright (C) 2025 by OpenFOAM Foundation, Website: https://openfoam.org

    If you are interested in which files are original OpenFOAM Foundation
    files, which OpenFOAM Foundation files were modified, and which files were
    newly created, see FILES.md.

    Multiphase Code Repository by HZDR is free software: you can redistribute
    it and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Multiphase Code Repository by HZDR is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
    Public License for more details.

    You should have received a copy of the GNU General Public License along
    with the Multiphase Code Repository by HZDR. If not, see
    <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "cipsaMultiphaseEuler.H"

// * * * * * * * * * * * * Private Member Functions  * * * * * * * * * * * * //

Foam::PtrList<Foam::volScalarField>
Foam::solvers::cipsaMultiphaseEuler::calcRhoAlphaBuoyancy()
{
    PtrList<volScalarField> rhoAlphaBuoyancy(phases.size());

    const volScalarField rhoContinuous
    (
        fluid.resolvedInterface().rhoContinuous()
    );

    forAll(movingPhases, movingPhasei)
    {
        const phaseModel& phase = movingPhases[movingPhasei];
        if
        (
            (continuousBuoyancy || interfaceParallelBuoyancy)
         && phase.continuous()
        )
        {
            rhoAlphaBuoyancy.set(phase.index(), rhoContinuous);
        }
        else
        {
            rhoAlphaBuoyancy.set(phase.index(), phase.rho());
        }
    }

    return rhoAlphaBuoyancy;
}


Foam::PtrList<Foam::volVectorField>
Foam::solvers::cipsaMultiphaseEuler::calcBuoyancySource
(
    PtrList<volScalarField>& rhoAlphaBuoyancy
)
{
    PtrList<volVectorField> buoyancySource(phases.size());
    fillFields("buoyancySource", dimensionSet(1, -2, -2, 0, 0), buoyancySource);

    forAll(movingPhases, movingPhasei)
    {
        const phaseModel& phase = movingPhases[movingPhasei];
        const volScalarField& alpha = phase;

        // Phase-specific buoyancy contribution
        buoyancySource[phase.index()] =
            alpha*(rhoAlphaBuoyancy[phase.index()] - rho)*buoyancy.g;

        // Remove normal buoyancy component from underresolved interfaces
        if (interfaceParallelBuoyancy && phase.continuous())
        {
            volVectorField nHat
            (
                volVectorField::New
                (
                    IOobject::groupName("nHat", phase.name()),
                    mesh,
                    dimensionedVector(dimless, Zero)
                )
            );

            forAll(movingPhases, phasej)
            {
                const phaseModel& otherPhase = movingPhases[phasej];

                if
                (
                    phase.index() == otherPhase.index()
                 || !otherPhase.continuous()
                )
                {
                    continue;
                }

                nHat += fluid.resolvedInterface().nHat(phase, otherPhase);
            }

            const volVectorField gParallel
            (
                buoyancy.g - (buoyancy.g & nHat)*nHat
            );

            buoyancySource[phase.index()] +=
                alpha*gParallel*(phase.rho() - rhoAlphaBuoyancy[phase.index()]);
        }
    }

    return buoyancySource;
}


Foam::PtrList<Foam::surfaceScalarField>
Foam::solvers::cipsaMultiphaseEuler::calcBuoyancySourcef
(
    PtrList<volScalarField>& rhoAlphaBuoyancy
)
{
    PtrList<surfaceScalarField> buoyancySourcef(phases.size());
    fillFields
    (
        "buoyancySourcef",
        dimensionSet(1, 0, -2, 0, 0),
        buoyancySourcef
    );

    forAll(movingPhases, movingPhasei)
    {
        const phaseModel& phase = movingPhases[movingPhasei];

        // Phase-specific buoyancy contribution
        buoyancySourcef[phase.index()] =
            alphafs[phase.index()]*(buoyancy.g & mesh.Sf())
           *(
                fvc::interpolate(rhoAlphaBuoyancy[phase.index()])
              - fvc::interpolate(rho)
            );

        // Remove normal buoyancy component from underresolved interfaces
        if (interfaceParallelBuoyancy && phase.continuous())
        {
            surfaceVectorField nHatfv
            (
                surfaceVectorField::New
                (
                    IOobject::groupName("nHatfv", phase.name()),
                    mesh,
                    dimensionedVector(dimless, Zero)
                )
            );

            forAll(movingPhases, phasej)
            {
                const phaseModel& otherPhase = movingPhases[phasej];

                if
                (
                    phase.index() == otherPhase.index()
                 || !otherPhase.continuous()
                )
                {
                    continue;
                }

                nHatfv += fluid.resolvedInterface().nHatfv(phase, otherPhase);
            }

            const surfaceVectorField gParallelf
            (
                buoyancy.g - (buoyancy.g & nHatfv)*nHatfv
            );

            buoyancySourcef[phase.index()] +=
                alphafs[phase.index()]*(gParallelf & mesh.Sf())
               *(
                    fvc::interpolate(phase.rho())
                  - fvc::interpolate(rhoAlphaBuoyancy[phase.index()])
                );
        }
    }

    return buoyancySourcef;
}


// ************************************************************************* //
